

#include <unistd.h>            
#include <fcntl.h>	
#include <netinet/in.h>
#include <arpa/inet.h>		
#include <sys/types.h>
#include <sys/socket.h>                                                                                                   
#include <sys/resource.h>
#include <sys/wait.h>
#include <stdio.h>
#include <string.h>     
#include <stdlib.h>
#include <ctype.h>
#include <sys/time.h>
#include <pthread.h>
#include <signal.h>
#include "udhcp/proto.h"

#define DEBUG 1

typedef struct {
	unsigned long int ipassign;
	unsigned long int ipdhcp;
	long int lease;
	time_t starttime;
	int isuse;
        char hw[6];
} ctrl_dhcp;

#define MAXIP 7		//( 7 remote (0:6) )

static ctrl_dhcp Tab_dhcp[MAXIP];
static unsigned long int  ethip;
static char *localpppip = 0;
static pthread_mutex_t mutex_access=PTHREAD_MUTEX_INITIALIZER;
static pthread_t lease_thread;

#define SLEEPINGTIME 60
//#define CLIENTID "BlueTooth"


#define NSIZ 128
static char DHCPHOSTNAME[NSIZ];

#define UINT void *

#define LOCKFILE "/var/run/ip_server.pid"

static int writelock() {
 	FILE *fd;
	fd=fopen(LOCKFILE,"w");
	if ( fd==NULL ) return 0;
	fprintf(fd,"%d",getpid());
	fclose(fd);
	return 1;

}

static void killppp(int channel) {
//#define LOCKPPPFILEF "/var/run/ppp%d.pid"
#define LOCKPPPLINKNAMEFILEF "/var/run/ppp-%d.pid"

	char filename[128];
	FILE *fd;
	int pid=-1;


//	sprintf(filename,LOCKPPPFILEF,channel);
	sprintf(filename,LOCKPPPLINKNAMEFILEF,channel);
	fd=fopen(filename,"r");
	if ( fd == NULL ) {
#ifdef DEBUG
	printf("Unable to open %s for killing ppp \n",filename);
#endif
		return;
}
	fgets(filename,strlen(filename),fd);
	fclose(fd);

	pid = atoi(filename);
#ifdef DEBUG
	printf("killing ppp %d due end of leasing \n",channel);
#endif
	if ( pid ) kill(pid,SIGTERM);

	


}


UINT  LeaseThread(void *pParam)
{
	int i;
	long int dl;
	time_t currenttime;

	while (1) {

	  sleep(SLEEPINGTIME);
	  
	  pthread_mutex_lock(&mutex_access);  
	  for(i=0;i<MAXIP;i++) {
		if ( Tab_dhcp[i].isuse ==  1 ) {
#ifdef DEBUG
			printf("check Lease for %d\n",i);
#endif
			currenttime=time(0);
#ifdef DEBUG1
			if (  (currenttime - Tab_dhcp[i].starttime ) > 30   && (currenttime - Tab_dhcp[i].starttime ) < 120 ) {	
#else
			if (  (currenttime - Tab_dhcp[i].starttime ) > ( Tab_dhcp[i].lease / 2.0) &&
            (currenttime - Tab_dhcp[i].starttime ) <  ( Tab_dhcp[i].lease *0.875 )
			 ) {	
#endif	
				
				if ( RenewLease(   Tab_dhcp[i].ipassign, Tab_dhcp[i].ipdhcp,&dl,Tab_dhcp[i].hw)  ) {
					Tab_dhcp[i].lease = dl;
					Tab_dhcp[i].starttime=currenttime;
				}
			
			}
#ifdef DEBUG1
			else if (  (currenttime - Tab_dhcp[i].starttime ) >=  120 ) {
#else
			else if (  (currenttime - Tab_dhcp[i].starttime ) >=  ( Tab_dhcp[i].lease *0.875 ) ) {
#endif

#ifdef DEBUG
			printf("Timeout for lease for %d killing PPP \n",i);
#endif
				//	Tab_dhcp[i].isuse=0;
			killppp(i);  // to do if     LOCALCTRL failed !!!!
				
		    }
		}
	}
		
	pthread_mutex_unlock(&mutex_access);  

    }		

  	//pthread_create(&lease_thread, NULL, LeaseThread,(void *)NULL);

    return NULL;
}


static int GetFreeCtrl(int lin) {

  if ( Tab_dhcp[lin].isuse== 1 ) return -1;
  Tab_dhcp[lin].isuse=1;	
  return lin;
}

static void FreeCtrl(int l) {

  Tab_dhcp[l].isuse=0;

}


static int init_interface(char * interf,char *scriptforeth) {

 	configure_eth(interf,scriptforeth) ;

	return 1;
}


#define ADD 		0
#define RELEASE 	1
#define PORTIPSERVER 71
#define ADDTAG 	"ADD"
#define RELEASETAG 	"RELEASE"
#define LINETAG 	"LINE= "
#define PORTTAG 		"PORT="

#define BUFSIZE 	256

#define ACK "ACK"
#define NACK "NACK"
#define NOIP "NOIP"

static int decode_req(char *buf, int numread,char *answer) {
	char *ptradd,*ptrrel,*ptrlin;
	char tmp[128];
	char ip1[128],ip2[128];

	struct in_addr sain;
	int lin;
	int ctrlfree=-1;

	ptradd = strstr(buf,ADDTAG)  ;
	ptrrel = strstr(buf,RELEASETAG)  ;
	ptrlin = strstr(buf,LINETAG)  ;

	sprintf(answer,"%s",NACK);	

	if ( !((ptradd || ptrrel ) && ptrlin) ) {
		printf("unknown request \n");
		return 0;
	}

	if ( ptrrel ) {
		sscanf( ptrrel+strlen(RELEASETAG),"%s%d",tmp,&lin);
		//printf("suppression de la ligne %d\n",lin);
		pthread_mutex_lock(&mutex_access);  

		if (  Tab_dhcp[lin].isuse ) {
			ReleaseIPtoDHCP(NULL,Tab_dhcp[lin].ipassign,Tab_dhcp[lin].ipdhcp,Tab_dhcp[lin].hw);
			FreeCtrl(lin);
		}
		strcpy(answer,ACK);
		pthread_mutex_unlock(&mutex_access);  

		return 1;
	}

	if ( ptradd ) {
	        char *msdns = NULL, *mswins = NULL;
		int test[6];
		int i;
		
		pthread_mutex_lock(&mutex_access);  

		sscanf(ptradd+strlen(ADDTAG),"%s%d %x:%x:%x:%x:%x:%x",tmp,&lin,test,test+1,test+2,test+3,test+4,test+5);

		for (i=0; i<6; i++)
		  Tab_dhcp[lin].hw[i] = test[i];
		
		printf("line:%d hw: %02x:%02x:%02x:%02x:%02x:%02x\n",lin, Tab_dhcp[lin].hw[0], Tab_dhcp[lin].hw[1], Tab_dhcp[lin].hw[2], Tab_dhcp[lin].hw[3], Tab_dhcp[lin].hw[4], Tab_dhcp[lin].hw[5]);

		ctrlfree = GetFreeCtrl(lin);
		if ( ctrlfree < 0 ) {
			//printf("ligne  %d pour le hardware deja utilise %s\n",lin,hw);
			sprintf(answer,"%s",NACK);	
			pthread_mutex_unlock(&mutex_access);  
			return 0;
		}
		//printf("ajout de la ligne  %d pour le hardware %s\n",lin,hw);
		//sprintf(clientID,"%s%d",CLIENTID,ctrlfree);
		if  ( RequestIPFromDHCP(NULL,Tab_dhcp[lin].hw,&Tab_dhcp[ctrlfree].ipassign,&Tab_dhcp[ctrlfree].ipdhcp,&Tab_dhcp[ctrlfree].lease,&msdns,&mswins,0) ) {
			Tab_dhcp[ctrlfree].starttime=time(0);
			Tab_dhcp[ctrlfree].isuse=1;
			if (localpppip) {
			  strcpy(ip1,localpppip);
			} else {
			  sain.s_addr=ethip;
			  strcpy(ip1,inet_ntoa( sain) );	
			}
			sain.s_addr=Tab_dhcp[ctrlfree].ipassign;
			strcpy(ip2,inet_ntoa( sain) ) ;	
			sprintf(answer,"%s %s:%s",ACK,ip1,ip2);
			if (msdns) {
			  strcat(answer," ");
			  strcat(answer,msdns);
			  printf("ip_server got DNS %s\n",msdns);
			  free(msdns);
			}
			if (mswins) {
			  strcat(answer," ");
			  strcat(answer,mswins);
			  printf("ip_server got WINS %s\n",mswins);
			  free(mswins);
			}
			pthread_mutex_unlock(&mutex_access);  
			return 1;
		}
		else {
			FreeCtrl(ctrlfree);
			sprintf(answer,"%s",NOIP);
			if (msdns)
			  free(msdns);
			if (mswins)
			  free(mswins);
			pthread_mutex_unlock(&mutex_access);  
			return 0;
		}
	}

	return 0;

}

int
wait_for_request(void){
	int sock = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	int salen;
	struct sockaddr_in 	sa_plus;
	char buf[BUFSIZE];
	char ans[BUFSIZE];
	memset ((void *) &sa_plus, 0, sizeof (sa_plus));
	sa_plus.sin_family = AF_INET;
	sa_plus.sin_addr.s_addr=inet_addr("127.0.0.1");
	sa_plus.sin_port = htons (PORTIPSERVER);
	if(sock < 0) {
	  printf("Unable to create socket, exiting\n");
	  return 0;
	}
	if (bind (sock, (struct sockaddr *) &sa_plus, sizeof (struct sockaddr)) < 0) {
	  printf("Unable to bind socket on port %d, exiting\n",PORTIPSERVER);
	  close(sock);
	  return 0;
	}	
	//printf("Waiting for requests on port %d\n",PORTIPSERVER);
	while (1) {
		int numread, port;
		char *ptrport;
		memset(buf,0,BUFSIZE);
		memset(ans,0,BUFSIZE);
		salen=sizeof(struct sockaddr);
		numread = recvfrom (sock,(void *)buf,BUFSIZE,0,(struct sockaddr *) &sa_plus, &salen);
		if (decode_req(buf,numread,ans) == 0 )  {
		  //printf("reception de %s sur la socket, but not usable sending NACK !!!\n",buf);
		} else {
		  //printf("reception de %s sur la socket -> send to port %d\n",buf,ntohs(sa_plus.sin_port));	
		}
		//printf("Sending answer %s\n",ans);
		ptrport = strstr(buf,PORTTAG);
		sscanf(ptrport+strlen(PORTTAG),"%d",&port);
		memset ((void *) &sa_plus, 0, sizeof (sa_plus));
		sa_plus.sin_family = AF_INET;
		sa_plus.sin_addr.s_addr=inet_addr("127.0.0.1");
		sa_plus.sin_port = htons (port);
		sendto(sock,(char *)ans,strlen(ans),0,(struct sockaddr *)&sa_plus,sizeof(struct sockaddr_in));
	}
}
 
 
/*
int wait_for_request() {
	
	int 			socksend;
	int 			flags,salen,numread,nonblock;
	struct sockaddr_in 	sa;
	fd_set			readfds;
	char 			buf[BUFSIZE];
 	char 			ans[BUFSIZE];



	
	socksend = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if  ( socksend == -1 ) return 0;
 	//nonblock=1;
	//if (setsockopt (socksend , SOL_SOCKET, SO_REUSEADDR, (char *) &nonblock, sizeof (nonblock)) == 0) {
	//	if ((flags = fcntl (socksend , F_GETFL, 0)) >=0) {
  // 			fcntl (socksend , F_SETFL, flags | O_NONBLOCK);
	//	}
	//}


	memset ((void *) &sa, 0, sizeof (sa));
 	sa.sin_family = AF_INET;
  sa.sin_addr.s_addr=INADDR_ANY;
	sa.sin_port = htons (PORTIPSERVER);

  if (bind (socksend, (struct sockaddr *) &sa, sizeof (struct sockaddr)) < 0) {
		return 0;
	}


  
 	for(;;) {
	//	FD_ZERO(&readfds);
 	//	FD_SET(socksend, &readfds);
  //		if (select(socksend+ 1, &readfds, NULL, NULL, NULL) == -1) {
	//		close(socksend);
	//		return 0;
	//	}
	  memset(buf,0,BUFSIZE);
		numread = recvfrom (socksend,  (void *)buf,BUFSIZE,0,(struct sockaddr *) &sa, &salen);
   	printf("envoi -> send to port %d\n",ntohs(sa.sin_port ));	
		printf("reception de %d octet sur la socket!!!\n",numread);

		if ( numread < 0 ) {
			close(socksend);
			return 0;
		}
		buf[numread] = 0;
		ans[0]=0;
		if ( decode_req(buf,numread,ans) == 0 )  {
#ifdef DEBUG
			printf("reception de %s sur la socket, but not usable sending NACK !!!\n",buf);
#endif
		}
		else {
#ifdef DEBUG
			printf("reception de %s sur la socket -> send to port %d\n",buf,ntohs(sa.sin_port ));	
#endif
		}
			sendto(socksend, (char *)ans,strlen(ans), 0,(struct sockaddr *) &sa, sizeof(struct sockaddr_in));
		
  
	}
	close(socksend);

}
*/

#define FILEN "/etc/bluedsl.conf"
#define NAMETAG "NAME="

static int GetDefaultHostname(char *DHCPHOSTNAME){
	char bf[NSIZ];
	FILE *fd;
	strcpy(DHCPHOSTNAME,"Inventel");
	fd=fopen(FILEN,"r");
	if ( fd == NULL ) return 0;
	while( fgets( bf,NSIZ,fd ) != NULL ) {
		if ( strstr(bf, NAMETAG) ) {
			int ll;
			strcpy(DHCPHOSTNAME,bf+strlen(NAMETAG) );
			ll=strlen(bf);
			while ( ll > 0 ) {
				if ( bf[ll] == 13 ) bf[ll] =0; if ( bf[ll] == 10 ) bf[ll] =0; if ( bf[ll] == ' ') bf[ll] =0; ll--;
			}
			strcpy(DHCPHOSTNAME,bf+strlen(NAMETAG) );
				fclose(fd);
				return 1;
		}
	}
	fclose(fd);
	return 0;


}

static void AddDeleteTable(unsigned long int ethip,char *ethname,int ADDRELEASE){

	#define IPTABLES "iptables"
	int iptablepid;
	if(!(iptablepid=fork())) {
     	int i = 0;
		 	char *ipopt[32];
		 	static char  ethn[16];
 		 	static char  ipethn[16];
			struct in_addr addr;
			int j;

			ipopt[i++] = IPTABLES;
 			ipopt[i++] = "-t";
 			ipopt[i++] = "nat";
			if ( ADDRELEASE == ADD )
 				ipopt[i++] = "-A";
			else
 				ipopt[i++] = "-D";
  			ipopt[i++] = "PREROUTING";
			ipopt[i++] = "-i";
			strcpy(ethn,ethname);
 			ipopt[i++] = ethn;
 			ipopt[i++] = "-p";
 			ipopt[i++] = "udp";
 			ipopt[i++] = "--dport";
 			ipopt[i++] = "68";
 			ipopt[i++] = "-j";
			ipopt[i++] = "DNAT";
			ipopt[i++] = "--to-destination";

			addr.s_addr= ethip;
			strcpy(ipethn, inet_ntoa( addr));
 			ipopt[i++] = ipethn;
			ipopt[i] =0;
	
     	execvp(IPTABLES,ipopt);
      _exit(0);
		}
	wait4(iptablepid,0,0,0);
}


#ifdef TESTMODE

#define USAGE    "\
Usage: %s [-n ] [-i eth ] [-s dhcphostname ] [ -c configfile ] [ -r eth0configscript ]\
 Where\
   -i means try to configure interface  eth instead of default %s interface\
   -n means no interface to configure \
   -s means use dhcphostname for querying external DHCP instead of %s defined in configuration file \
   -r means use eth0configscript instead of %s to configure eth\
   -c means used configfile for overwritting default behavior \n"


#define DEFAULTINTER "eth0"
#define DEFAULT_SCRIPT  "/root/IPSERVER/udhcp/script.sh"

int daemonize() {
  pid_t pid;
  int fd;
  if ((pid = vfork()) < 0) {
    return -1 ; 
  }
  if (pid != 0) {
    /* parent */
    exit(0);		/* parent dies */
  }
  setsid();
  chdir("/");
  close(0);
  close(1);
  close(2);
  /* Direct stdin,stdout,stderr to '/dev/null' */
  fd = open("/dev/null", O_RDWR);
  dup2(fd, 0); dup2(fd, 1); dup2(fd, 2);
  return 0 ; 
}

int main(int argc,char *argv[])
{

	char ETHNAME[NSIZ];
	char SCRIPT[NSIZ];
	int i,codeend;
	int daemon=1 ;
  
	strcpy(ETHNAME,DEFAULTINTER);
	GetDefaultHostname(DHCPHOSTNAME);

	strcpy( SCRIPT ,DEFAULT_SCRIPT );
	
	for ( i = 1; i < argc; i ++ )
   	 {
      		if ( argv[i][0] == '-' ) {
		  /*
 			if ( strcmp( &argv[i][1], "n" ) == 0 ) {
				isEth=0; 
             		}
		  */
		  if ( strcmp( &argv[i][1], "i" ) == 0 ) {
		    i++;
		    strcpy(ETHNAME,argv[i] );
		  }
		  /*
		    else if ( strcmp( &argv[i][1], "s" ) == 0 ) {
		    i++;
		    strcpy(DHCPHOSTNAME,argv[i] );
		    }
		  */
		  else if ( strcmp( &argv[i][1], "l" ) == 0 ) {
		    i++;
		    localpppip = strdup(argv[i]);
		    printf("Local PPP IP set manually: %s\n",localpppip);
		  }
		  else if ( strcmp( &argv[i][1], "r" ) == 0 ) {
		    i++;
		    strcpy(SCRIPT ,argv[i] );
		  }
		  else if ( strcmp( &argv[i][1], "n" ) == 0 ) {
		    i++;
		    daemon = 0 ;
		  }      
		  else if ( strcmp( &argv[i][1], "h" ) == 0 ) {
		    printf( USAGE, argv[0],ETHNAME,DHCPHOSTNAME,SCRIPT );
		    return 1;
		  }
		}
		
	 }  
	
   if (daemon == 1)
     daemonize() ;
   
	if ( writelock() == 0 ) printf("Warning: cannot write pid in %s file for future reload.. Continue\n",LOCKFILE);
	
	if (  ! init_interface(ETHNAME, SCRIPT) ) {
	  printf("Unable du configure eth0. Exiting ...\n");
	  return 0;
	}
	
	ethip =   LoadEThIP();
	if ( ! ethip ) {
	  printf("Unable du find ethernet interface . Exiting ...\n");
	  return 0;
	}
	
	pthread_create(&lease_thread, NULL, LeaseThread,(void *)NULL);
	
	AddDeleteTable(ethip,ETHNAME,ADD);
	codeend = wait_for_request();
	AddDeleteTable(ethip,ETHNAME,RELEASE);

	if (localpppip)
	  free(localpppip);
	
	return	codeend;
	
}
 
#endif
 
 

























